# Mostly copied from Resque in order to have similar test environment.
# https://github.com/defunkt/resque/blob/master/test/test_helper.rb
dir = File.dirname(File.expand_path(__FILE__))

require 'rubygems'
require 'bundler'
begin
  Bundler.setup(:default, :development)
rescue Bundler::BundlerError => e
  $stderr.puts e.message
  $stderr.puts "Run `bundle install` to install missing gems"
  exit e.status_code
end
require 'test/unit'
require 'shoulda'
require 'mocha/setup'

$LOAD_PATH.unshift(File.join(File.dirname(__FILE__), '..', 'lib'))
$LOAD_PATH.unshift(File.dirname(__FILE__))
require 'resque'
require 'resque-noti-failure'

unless ENV['TRAVIS']
  #
  # make sure we can run redis
  #

  if !system("which redis-server")
    puts '', "** can't find `redis-server` in your path"
    puts "** try running `sudo rake install`"
    abort ''
  end

  at_exit do
    next if $!

    if defined?(MiniTest)
      exit_code = MiniTest::Unit.new.run(ARGV)
    else
      exit_code = Test::Unit::AutoRunner.run
    end

    pid = `ps -A -o pid,command | grep [r]edis-test`.split(" ")[0]
    puts "Killing test redis server..."
    Process.kill("KILL", pid.to_i)
    exit exit_code
  end

  puts "Starting redis for testing at localhost:9736..."
  `redis-server #{dir}/redis-test.conf`
  Resque.redis = 'localhost:9736'
else
  Resque.redis = 'localhost:6379'
end

class BadJob
  def self.perform(name=nil)
    msg = name ? "Bad job, #{name}" : "Bad job!"
    raise msg
  end
end

class Test::Unit::TestCase
end
