require 'helper'
require 'rack/test'

ENV['RACK_ENV'] = 'test'

class TestServer < Test::Unit::TestCase
  include Rack::Test::Methods

  def setup
    Noti.app = 'fake-noti-app-id'
  end

  def app
    Resque::Server
  end

  def test_it_get_index
    get '/noti'
    assert last_response.ok?
    assert_match 'Subscribe', last_response.body
  end

  def test_it_subscribe
    object = mock('noti-request-token')
    object.expects(:request_token).returns('fake-token-id')
    object.expects(:redirect_url).returns('http//notiapp.com/subscribe')

    ::Noti::Token.expects(:create_request_token).returns(object)
    get '/noti/subscribe'
    assert last_response.redirect?
  end

  def test_it_confirm
    get '/noti/confirm'
    assert last_response.redirect?
  end

end
